#include <iostream>
#include "dlist.h"

using namespace std;

void test_copy(Dlist<int> l)
{
    int *ip = new int(1);
    l.insertFront(ip);
}

int main(int argc, char *argv[])
{
    int result = 0;

    Dlist<int> ilist;
    int *ip = new int(1);
    ilist.insertFront(ip);

    // Now ilist should be (1)

    // test removing from a list of size one.
    ip = ilist.removeFront();
    if(*ip != 1)
        result = -1;
    delete ip;

    if(!ilist.isEmpty())
        result = -1;

    // Now ilist should be ()

    ip = new int(4);
    ilist.insertFront(ip);
    
    // Now ilist should be (4)

    ip = new int(5);
    ilist.insertBack(ip);

    // Now ilist should be (4 5)

    ip = new int(3);
    ilist.insertFront(ip);

    // Now ilist should be (3 4 5)

    ip = new int(2);
    ilist.insertFront(ip);

    // Now ilist should be (2 3 4 5)

    ip = new int(6);
    ilist.insertBack(ip);

    // Now ilist should be (2 3 4 5 6)

    ip = new int(7);
    ilist.insertBack(ip);

    // Now ilist should be (2 3 4 5 6 7)

    ip = ilist.removeFront();
    if(*ip != 2)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (3 4 5 6 7)

    ip = ilist.removeBack();
    if(*ip != 7)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (3 4 5 6)

    ip = new int(7);
    ilist.insertBack(ip);

    // Now ilist should be (3 4 5 6 7)

    ip = ilist.removeFront();
    if(*ip != 3)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (4 5 6 7)

    ip = ilist.removeFront();
    if(*ip != 4)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (5 6 7)

    ip = ilist.removeBack();
    if(*ip != 7)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (5 6)

    ip = ilist.removeBack();
    if(*ip != 6)
        result = -1;
    delete ip;

    if(ilist.isEmpty())
        result = -1;

    // Now ilist should be (5)

    ip = ilist.removeBack();
    if(*ip != 5)
        result = -1;
    delete ip;

    if(!ilist.isEmpty())
        result = -1;

    // Now ilist should be ()

    ip = new int(4);
    ilist.insertFront(ip);
    
    // Now ilist should be (4)

    ip = new int(5);
    ilist.insertBack(ip);

    // Now ilist should be (4 5)

    ip = new int(3);
    ilist.insertFront(ip);

    // Now ilist should be (3 4 5)

    test_copy(ilist);
    Dlist<int> ilist_copy(ilist);

    ip = ilist_copy.removeBack();
    if(*ip != 5)
        result = -1;
    delete ip;

    if(ilist_copy.isEmpty())
        result = -1;

    Dlist<int> ilist_assign;
    ilist_assign = ilist;

    ilist_copy = ilist_assign;

    return result;
}
