#include <unistd.h>
#include <stdio.h>

int main(int argc, char* argv[], char* envp[]) {
	if (argc == 1) {
		fprintf(stderr, "No program to run.\n");
		return 1;
	}
	for (int i = 0; i < argc - 1; ++i) {
		argv[i] = argv[i + 1];
	}
	argv[argc - 1] = NULL;
	int err = 0;
	if ((err = execve(argv[0], argv, envp))) {
		perror("execve");
		return err;
	}
	return 0;
}

